using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace FlashTimer {
    public partial class FrmMain : Form {
        public bool cantClose = false;//ƃAvP[VIĂ܂tH[i͂߂ɊJtH[j̏ꍇtrue
        private DateTime startTime;//쓮Jn
        private TimeSpan setTime;//Zbgc莞
        private TimeSpan havePassedTime;//ݐϊ莞ԁiݑ蒆̎Ԃ܂܂Ȃj
        private DateTime stopTime;//ꎞ~
        public FrmMain() {
            InitializeComponent();
            cantClose = true;
        }
        /// <summary>
        /// V^C}[i@\[hŁjNB
        /// </summary>
        /// <param name="setByAbsoluteTime">ŃZbg邩ǂ</param>
        /// <param name="message">\郁bZ[W</param>
        /// <param name="interval">_ŊԊu</param>
        public FrmMain(bool setByAbsoluteTime, string message, int interval) {
            InitializeComponent();
            chkSetByAbsoluteTime.Checked = setByAbsoluteTime;
            txtMsg.Text = message;
            nudBlink.Value = interval;
            Size = MinimumSize = MaximumSize = new Size(Width, 340);
            btnOption.Text = "k";
        }

        //쓮ɂ
        private void start() {
            timer.Enabled = true;
            chkSetByAbsoluteTime.Enabled = nudAbsHour.Enabled = nudAbsMinute.Enabled = nudAbsSecond.Enabled
            = nudHour.Enabled = nudMinute.Enabled = nudSecond.Enabled = btnReset.Enabled = false;
            btnStartStop.Text = "Xgbv";
        }
        //~Ԃɂ
        private void stop() {
            timer.Enabled = false;
            nudHour.Enabled = nudMinute.Enabled = nudSecond.Enabled = !(
            nudAbsHour.Enabled = nudAbsMinute.Enabled = nudAbsSecond.Enabled = chkSetByAbsoluteTime.Checked);
            chkSetByAbsoluteTime.Enabled= btnReset.Enabled = true;
            btnStartStop.Text = "X^[g";
        }
        private void alarm() {
            (new Alert((int)nudBlink.Value,txtMsg.Text)).Show();
        }

        private void btnStartStop_Click(object sender, EventArgs e) {
            if (timer.Enabled) {
                //쓮(ꎞ~)
                stop();
                havePassedTime += DateTime.Now - startTime;
                stopTime = DateTime.Now;
            }
            else {
                //ҋ@(쓮)
                if (nudHour.Value + nudMinute.Value + nudSecond.Value == 0 && !chkSetByAbsoluteTime.Checked) return;
                if (chkSetByAbsoluteTime.Checked) {
                //Ŏw肷Ƃ͎c莞ԂɊZăX^[g(p͂蓾Ȃ)
                    DateTime goalTime = DateTime.Today;
                    goalTime += new TimeSpan((int)nudAbsHour.Value, (int)nudAbsMinute.Value, (int)nudAbsSecond.Value);
                    if (goalTime < DateTime.Now) {
                        goalTime+=new TimeSpan(1,0,0,0);
                    }
                    setTime = goalTime - DateTime.Now;
                }
                else {
                    setTime =
                        (setTime == new TimeSpan()) ?
                        new TimeSpan((int)nudHour.Value, (int)nudMinute.Value, (int)nudSecond.Value) :
                        setTime - (stopTime - startTime);//păX^[gƂ͕bȉ
                }
                startTime = DateTime.Now;
                start();
            }
        }

        private void btnReset_Click(object sender, EventArgs e) {
            if (timer.Enabled) return;
            nudHour.Value = nudMinute.Value = nudSecond.Value = 0;
            lblSubSecond.Text = "0";
            lblPassedSubSecond.Text = "0";
            havePassedTime = new TimeSpan();
            setTime=new TimeSpan();
            lblPassed.Text = "00:00:00";
            Text = "tbV^C}[";
        }

        private void timer_Tick(object sender, EventArgs e) {
            TimeSpan _passed = DateTime.Now - startTime;
            if (_passed > setTime) {
                stop();
                alarm();
                setTime = new TimeSpan();
                nudHour.Value = nudMinute.Value = nudSecond.Value = 0;
                lblSubSecond.Text = "0";
                lblPassedSubSecond.Text = "0";
                havePassedTime = new TimeSpan();
                setTime=new TimeSpan();
                lblPassed.Text = "00:00:00";
                Text = "tbV^C}[";
                return;
            }
            TimeSpan remain = setTime - _passed;
            nudHour.Value = remain.Hours;
            nudMinute.Value = remain.Minutes;
            nudSecond.Value = remain.Seconds;
            lblSubSecond.Text=string.Format("{0:0}",remain.Milliseconds/100);
            _passed += havePassedTime;
            lblPassed.Text = string.Format("{0:hh:mm:ss}", new TimeSpan(_passed.Hours, _passed.Minutes, _passed.Seconds));
            lblPassedSubSecond.Text = string.Format("{0:0}", _passed.Milliseconds / 100);
            Text = string.Format("{0:hh:mm:ss}", new TimeSpan(remain.Hours, remain.Minutes, remain.Seconds));
        }

        private void btnOption_Click(object sender, EventArgs e) {
            if (Height ==153) {
                Size = MinimumSize = MaximumSize = new Size(Width, 340);
                btnOption.Text = "k";
            }
            else {
                Size = MinimumSize = MaximumSize = new Size(Width, 153);
                btnOption.Text = "g";
            }
        }

        private void chkSetByAbsoluteTime_CheckedChanged(object sender, EventArgs e) {
            nudHour.Enabled = nudMinute.Enabled = nudSecond.Enabled = !(
            nudAbsHour.Enabled = nudAbsMinute.Enabled = nudAbsSecond.Enabled = chkSetByAbsoluteTime.Checked);
        }

        private void btnNewWindow_Click(object sender, EventArgs e) {
            (new FrmMain(chkSetByAbsoluteTime.Checked, txtMsg.Text, (int)nudBlink.Value)).Show();
        }

        private void remainChanged(object sender, EventArgs e) {
            if(timer.Enabled)return;
            setTime = new TimeSpan();//i~Ɂjc莞ԂύXꍇ͌pvł͂Ȃ̂łłɑ肵̎Ԃ
            lblSubSecond.Text = "0";
        }

        private void numericUpDownEntered(object sender, EventArgs e){
            ((NumericUpDown)sender).Select(0, 10);
        }

        private void FrmMain_FormClosing(object sender, FormClosingEventArgs e) {
            if (cantClose && Application.OpenForms.Count >= 2) {
                this.Hide();
                e.Cancel = true;
            }
            else {
                int shownforms = 0;
                foreach (Form f in Application.OpenForms) {
                    if (f.Visible) shownforms++;
                }
                if (shownforms == 1) {
                    foreach (Form f in Application.OpenForms) {
                        ((FrmMain)f).cantClose = false;
                    }
                }
            }
        }

        private void FrmMain_FormClosed(object sender, FormClosedEventArgs e) {
            int shownforms = 0;
            foreach (Form f in Application.OpenForms) {
                if (f.Visible) shownforms++;
            }
            if (shownforms == 0) Application.Exit();
        }
    }
}